from datetime import date
from typing import Any

from .rules.rule import CalendarRule
from .rules.loader import load_rules


class Calendar:
    def __init__(self, rules_config: list[Any]) -> None:
        self._rules: list[CalendarRule] = load_rules(rules_config)

    def match_day(self, qdate: date) -> bool:
        included = False

        for rule in self._rules:
            evaled = rule.apply(qdate)
            if evaled.applicable:
                included = evaled.included

        return included
