from pytest import fixture
from datetime import date
from notify.calendar.rules.exclude_dow import ExcludeDayOfWeek
from notify.calendar.rules.rule import RuleResult


@fixture
def rule() -> ExcludeDayOfWeek:
    return ExcludeDayOfWeek(2)


def test_days(rule: ExcludeDayOfWeek) -> None:
    assert rule.apply(date(2022, 9, 13)).applicable is False
    assert rule.apply(date(2022, 9, 14)) == RuleResult(applicable=True, included=False)
    assert rule.apply(date(2022, 9, 15)).applicable is False
