from pytest import fixture
from datetime import date
from notify.calendar.rules.exclude_holidays import ExcludeHolidays
from notify.calendar.rules.rule import RuleResult


@fixture
def rule() -> ExcludeHolidays:
    return ExcludeHolidays("HU")


def test_christmas(rule: ExcludeHolidays) -> None:
    assert rule.apply(date(2021, 12, 23)).applicable is False
    assert rule.apply(date(2021, 12, 24)) == RuleResult(applicable=True, included=False)
    assert rule.apply(date(2021, 12, 25)) == RuleResult(applicable=True, included=False)
    assert rule.apply(date(2021, 12, 26)) == RuleResult(applicable=True, included=False)
    assert rule.apply(date(2021, 12, 27)).applicable is False
