from datetime import date
from notify.calendar.rules.include_days import IncludeDays
from notify.calendar.rules.rule import RuleResult


def test_no_included_days() -> None:
    rule = IncludeDays(days=[])
    assert rule.apply(date(2022, 9, 18)).applicable is False


def test_one_included_day() -> None:
    rule = IncludeDays(days=[date(2022, 9, 18)])

    assert rule.apply(date(2022, 9, 17)).applicable is False
    assert rule.apply(date(2022, 9, 18)) == RuleResult(applicable=True, included=True)
    assert rule.apply(date(2022, 9, 19)).applicable is False


def test_two_included_day() -> None:
    rule = IncludeDays(days=[date(2022, 9, 19), date(2022, 9, 18)])

    assert rule.apply(date(2022, 9, 17)).applicable is False
    assert rule.apply(date(2022, 9, 18)) == RuleResult(applicable=True, included=True)
    assert rule.apply(date(2022, 9, 19)) == RuleResult(applicable=True, included=True)
    assert rule.apply(date(2022, 9, 20)).applicable is False
