from pytest import fixture
from datetime import date
from notify.calendar.rules.include_weekdays import IncludeWeekdays
from notify.calendar.rules.rule import RuleResult


@fixture
def rule() -> IncludeWeekdays:
    return IncludeWeekdays()


def test_weekdays(rule: IncludeWeekdays) -> None:
    assert rule.apply(date(2022, 9, 19)) == RuleResult(applicable=True, included=True)
    assert rule.apply(date(2022, 9, 20)) == RuleResult(applicable=True, included=True)
    assert rule.apply(date(2022, 9, 21)) == RuleResult(applicable=True, included=True)
    assert rule.apply(date(2022, 9, 22)) == RuleResult(applicable=True, included=True)
    assert rule.apply(date(2022, 9, 23)) == RuleResult(applicable=True, included=True)


def test_weekend(rule: IncludeWeekdays) -> None:
    assert rule.apply(date(2022, 9, 24)).applicable is False
    assert rule.apply(date(2022, 9, 25)).applicable is False
