from datetime import date
from .rule import CalendarRule, RuleResult


class ExcludeDayOfWeek(CalendarRule):
    def __init__(self, day: int):
        super().__init__()

        self._exclude_day = day

    def apply(self, day: date) -> RuleResult:
        if day.weekday() == self._exclude_day:
            return RuleResult(applicable=True, included=False)
        else:
            return RuleResult(applicable=False, included=False)
