from datetime import date
import holidays as pyholidays
from .rule import CalendarRule, RuleResult


class ExcludeHolidays(CalendarRule):
    def __init__(self, country: str) -> None:
        super().__init__()
        self._holidays = pyholidays.country_holidays(country)  # type: ignore

    def apply(self, day: date) -> RuleResult:
        if day in self._holidays:
            return RuleResult(applicable=True, included=False)
        else:
            return RuleResult(applicable=False, included=False)
