from datetime import date
from .rule import CalendarRule, RuleResult


class ExcludeRange(CalendarRule):
    def __init__(self, from_day: date, to_day: date) -> None:
        super().__init__()
        self._from_day = from_day
        self._to_day = to_day

    def apply(self, day: date) -> RuleResult:
        if self._from_day <= day <= self._to_day:
            return RuleResult(applicable=True, included=False)
        else:
            return RuleResult(applicable=False, included=False)
