from datetime import date
from .rule import CalendarRule, RuleResult


class IncludeDays(CalendarRule):
    def __init__(self, days: list[date]):
        super().__init__()
        self._days = set(days)

    def apply(self, day: date) -> RuleResult:
        if day in self._days:
            return RuleResult(applicable=True, included=True)
        else:
            return RuleResult(applicable=False, included=False)
