from datetime import date
from .rule import CalendarRule, RuleResult

accepted_weekdays = [0, 1, 2, 3, 4]


class IncludeWeekdays(CalendarRule):
    def apply(self, day: date) -> RuleResult:
        if day.weekday() in accepted_weekdays:
            return RuleResult(applicable=True, included=True)
        else:
            return RuleResult(applicable=False, included=False)
