from dataclasses import dataclass
from datetime import date


@dataclass(frozen=True)
class RuleResult():
    applicable: bool
    included: bool


class CalendarRule():
    def __init__(self) -> None:
        pass

    def apply(self, day: date) -> RuleResult:
        raise NotImplementedError("This method must be implemented by a subclass")
